// $Id: nwWrapper.js,v 1.5 2003/02/23 10:02:35 russcoon Exp $
// Copyright (c) 2000-2003 Alex Russell
// Licensed under the Academic Free License version 1.1

// This file provides an example of a "wrapper" script that can be customized
// to provide "one include" capability across a number of pages for setting 
// common netWindows options and including a common set of widgets. For 
// examples of how to include netWindows WITHOUT the aid of this (or a similar)
// hand-holding script, please see the source code for new_core_test.html.

// to accomidate a different server/location for the netWindows installation, 
// simply configure the following two lines to match your server envrionment.
var NWrootURL = "http://alex.netWindows.org/cvs/";

// if you've changed the directory under the preceeding URL where the core 
// netWindows scripts reside, indicate the name if this directory in the next 
// variable (trailing slash required)
var NWcorePathDir = "winScripts/";

// netWindows configuration variables. 
// All of the currently supported options are listed below with descriptions.
// Those options that are commented out simply match their default values for
// this example or are not frequently used.

// The NWconfig array MUST be declared (and its values set) BEFORE 
// netWindows.js is included for it's options to be obeyed
var NWconfig = new Array();

// specifies to the __config__ object the name of the directory where the core
// netwindows scripts reside
NWconfig["corePath"]=NWcorePathDir;

// the location of the widget scripts
// NWconfig["widgetPath"]=NWcorePathDir+"widgets/";

// the location of images
// NWconfig["imgPath"]="images/";

// the location of application or sample code
// NWconfig["appPath"]="appScripts/";

// determines whether or not event handlers should be set on the document as
// as side effect of loading the netWindows core scripts. If this is set to
// "false", __env__.setEventHandlers() MUST be called MANUALLY before onLoad
// fires in order to assure correct functioning of the netWindow environment.
// NWconfig["autoSetHandlers"]=true;

// findWidgets controls whether or not netWindows should traverse the documents
// DOM tree when onLoad fires in search of inline constructors. If set to
// "false", inline constructors that are not explicitly specified by
// "searchIds" will be ignored.
// NWconfig["findWidgets"]=true;

// "searchIds" allows one to specify a set of element IDs (as given by the HTML
// "id" property) that should be searched for inline constructors, irregardless
// of whether or not "findWidgets" is set to "true". This property allows one
// to use "searchIds" as a way of optimizing the load procedure for a page by
// decreasing the ammount of time spent post-load in searching for inline
// constructors.
// NWconfig["searchIds"]=['foo','bar'];

// specifies whether or not the GET string of a page should be parsed for 
// further configuration directives. This defaults to "false", but when set to
// "true" can provide a quick method for debugging pages without needing to
// modify this file in any way.
// NWconfig["obeyRequestEnv"]=false;

// toggle text file retreival caching
// NWconfig["cacheTxtURLData"]=true;

// set the following to false to dissable tooltips.
// NWconfig["includeTooltips"]=true;

// the path relative to the document including this file of the 
// netWindows "root". The option "NWroot" is another alias for this proprety.
NWconfig["rootPath"]="./";

// enable or disable netWindows themes on widgets. Setting to false will not 
// remove all sytles from widget nodes, but will remove all style-only 
// parameters that were previously set via the __theme__ object.
NWconfig["applyThemedStyles"]=false;

// specified whether or not the netWindows core scripts will be included in
// the current environment. This is a handy way to test whether or not your
// pages "downgrade" without having to remove any code.
// NWconfig["dhtmlEnabled"]=true;

// determines whether or not the specified core and widget scripts will begin
// being included as a "side effect" of netWindows.js loading. If this is set
// to "false", one must MANUALLY call __config__.includeScripts() BEFORE the
// onLoad event fires in order to ensure that the netWindows envrionment is
// correctly noted. This option is of limited practical use. It will be much
// more common to toggle "dhtmlEnabled" instead.
// NWconfig["autoLoad"]=true;

// specifies whether or not the debugging console should be included 
// (although whether or not it is actually instantiated is another matter). 
// Set to true when debugging output is no longer desired.
// NWconfig["isProduction"]=false;

// give the name of an optional function that will be called with no arguments 
// once netWindows.js has finished initializing. Note that the specified
// function need not be declared in this script, but must exist in the
// environment. Only one function may be specified.
// The specified function will be called BEFORE onLoad but directly AFTER 
// the require() calls for the core scripts have been made.
NWconfig["loadEvalName"]="loadNWExtras";

// define the function that cleans up after the core scripts have been loaded
function loadNWExtras(){
	with(__scripts__){
		// these are just an example of widgets that can be added
		require(__config__.widgetPath+"button_widget.js");
		require(__config__.widgetPath+"combo_box_widget.js");
		require(__config__.widgetPath+"sort_data_table_widget.js");
		require(__config__.widgetPath+"gen_data_table_widget.js");
		// the use of __scripts__.doOnFinalize() callbacks can provide
		// a handy way of "delaying" an action until a required object
		// is known to be available. Multiple functions can be
		// specified to be called per URL finalize() call.

		// comment this line out to remove the debugging console from NW pages.
		doOnFinalize(__config__.corePath+"console.js", addConsole);
	}
	return true;
}

function addConsole(){
	__sig__.connect(__env__, __env__.onLoad, null, function(){create_console('<<debugging console initialized>>', 0, 0, 'right', 'top', 400, 300, 100);});
}

// a little magic to begin to actually include the netWindows framework
document.write('<script language="JavaScript" src="'+NWrootURL+NWcorePathDir+'netWindows.js" type="text/javascript"><\/script>');
