// $Id: console.js,v 1.30 2003/01/12 09:38:14 russcoon Exp $
// Copyright (c) 2000-2003 Alex Russell
// Licensed under the Academic Free License version 1.1
///////////////////////////////////////////////////////////////////////////////
// Notes On The Usage of This Script:
//
//  THIS SCRIPT WILL _NOT_ WORK IN A 4.X BROWSER
//
//  To Get a console on your page, include this file as follows...
//
//  <SCRIPT language="JavaScript1.2" type="text/javascript" src="console.js"></script>
//
//  Make sure that it's put inside the <head></head> element.
//  To actually display a console on your page, modify the body tag declaration as so:
//
/*
		<body onLoad="create_console('<<this is the console, page feedback should be directed here>>', 0, 0, 'right', 'top', 300, 300, 25);">
*/
//  This particular onLoad call creates a console that automatically has 
//  "<<this is the console..." written to it, starts at 0 pixels to the left 
//  of the page, 25 pixels from the top of the page, and measures 300px by 
//  300px. It would also be partialy transparent. Simple, right?
//
//  Also available are percentages for both width and height. Using percentages, 
//  your constructor might look like:
/*
		<body onLoad="create_console('', 20, 20, 'left', 'bottom', '50%', '50%', 100);">
*/
//  which would create an opaque console in the bottom left quarter of the page.
//  notice that the width and height arguments are strings in this case.
//  some explination of the argurments (in order):
/*
	ConsoleText
		the text that appears at the console when it is created
	xOffset
		the number of pixels (as an integer) that you would like the console
		offset in the direction specified by xAlign (either left or right, see below)
	yOffset
		the number of pixels (as an integer) that you would like the console
		offset in the direction specified by yAlign (either top or bottom, see below)
	xAlign
		a string, either "left" or "right", specifying which side of the screen
		the console should be aligned too
	yAlign
		a string, either "top" or "bottom", specifying which side of the screen
		the console should be aligned too in the y axis
	wide
		specifies, in pixels (integer) or percentage (string), the width of the console
	high
		specifies, in pixels (integer) or percentage (string), the desired height of the console
	opacity
		a whole number (integer) specifying the percentage that the console should be opaque.
*/
//
//  To start using this script to debug, use the stdout() function listed 
//  below. To do so, give it a text argument. Each new call to stdout() places 
//  the output on a new line.
//
//  To clear output, just type "cls" or "clear" in the input area and hit
//  enter (or the 'Execute' button).
//
//		alex@netWindows.org
//
////////////////////////////////////////////////////////////////////////////////


// make this file play nice with netWindows
if(window.__scripts__){
	__scripts__.provide(__config__.corePath+"console.js");
}


//global variables (ick), we need them initialized to nodes here so we don't
//get yelled at when people try to call stdout() before the onload handler fires.
var cRootElem = document.createElement("DIV");
cRootElem.setAttribute("theme", "backgroundColor: content_bgcolor;");
var cInputElem = document.createElement("DIV");
var cOutput = document.createElement("DIV");
var cOutputOrder = "append"; //change to "prepend" to place new output at the top
var cLineNo = 1;
var isCreated = false;
var isIE = false;
var isIEmac = false;
var cCommands = [];
var cCommandsArrowOffset = 0;
if(document.all){
	isIE = true;
	if(navigator.appVersion.indexOf("Macintosh") != -1){
		isIEmac = true;
	}
}

var cForm = document.createElement("form");
cForm.onsubmit = function(){checkSpecial(this.eval_code.value); return false;}

var cTextF = document.createElement("input");
cTextF.onkeyup = function(evt){
	if(!evt){ evt = window.event; }
	if(evt.keyCode){
		if(evt.keyCode == 38){
			if(cCommands.length == 0){ return true; }
			if(cCommandsArrowOffset>=cCommands.length){
				cCommandsArrowOffset=cCommands.length-1;
			}
			if(cCommandsArrowOffset<0){
				cCommandsArrowOffset=0;
			}
			cTextF.value = cCommands[cCommands.length-cCommandsArrowOffset-1];
			cCommandsArrowOffset++;
		}else if(evt.keyCode == 40){
			if(cCommands.length == 0){ return true; }
			cCommandsArrowOffset--;
			if(cCommandsArrowOffset<0){
				cCommandsArrowOffset=0;
				cTextF.value = "";
			}else{
				if(cCommandsArrowOffset>cCommands.length){
					cCommandsArrowOffset=cCommands.length-1;
				}
				cTextF.value = cCommands[cCommands.length-cCommandsArrowOffset-1];
			}
		}
	}
	return true;
}
cTextF.setAttribute("theme", "backgroundColor: menu_hl_bgcolor;");
with(cTextF.style){
	fontSize = "13px";
	letterSpacing = "1px";
	fontFamily = "arial";
	width = "150px";
	height = "20px";
	border = "1px solid Gray";
}
if(!isIEmac){ cTextF.setAttribute("type", "text"); }

cTextF.setAttribute("name", "eval_code");
cTextF.setAttribute("id", "eval_code");

var inputVarSendB = document.createElement("input");
inputVarSendB.setAttribute("theme", "backgroundColor: menu_bgcolor;");
inputVarSendB.onclick = function(){checkSpecial(this.parentNode.firstChild.value);};

if(!isIEmac){
	inputVarSendB.setAttribute("type","button");
}
inputVarSendB.setAttribute("value", "Execute");
inputVarSendB.value = "Execute";

with(inputVarSendB.style){
	height = "20px";
	width = "90px";
	fontSize = "13px";
	letterSpacing = "0.5px";
	fontFamily = "arial";
	border = "1px solid black";
}


cForm.appendChild(cTextF);
cForm.appendChild(inputVarSendB);
cInputElem.appendChild(cForm);
cInputElem.style.height = "25px";
cInputElem.style.overflow = "hidden";
cRootElem.appendChild(cInputElem);

// input line hack courtsey of Kevin Driver
function checkSpecial(textN){
	if(textN == "help"){
		stdout("This console script is designed to aid DHTML developers in debugging complex scripts and quick-firing events. Code placed in the above text area will be evaluated in the global scope when the form is sbmitted (either with the above 'Execute' button, or with <CR>).");
		stdout("Any valid javascript may be placed in the input box");
		var NewLine = document.createElement("DIV");
		var Break_line1 = document.createElement("blockquote");
		var Break_line2 = document.createElement("BR");
		var Break_line3 = document.createElement("BR");
		//  these could be paramaters or something, you know, if I wanted to
		//  type that much =)
		NewLine.style.fontSize = "13px";
		NewLine.style.fontFamily = "sans-serif";
		NewLine.style.borderTop = "1px #959595 solid";
		var Methods = document.createTextNode(cLineNo + " " + " Console Specific Methods:");
		var Std = document.createTextNode("stdout(\"arg\"); - prints string in \"arg\" to console");
		var Cl = document.createTextNode("cls or clear - clears the console");
		var Help = document.createTextNode("help - displays this help message");
		cLineNo++;
		cOutput.appendChild(NewLine);
		NewLine.appendChild(Methods);
		NewLine.appendChild(Break_line1);
		with(Break_line1){
			appendChild(Std);
			appendChild(Break_line2);
			appendChild(Cl);
			appendChild(Break_line3);
			appendChild(Help);
		}
		stdout("This script was developed by Alex Russell <alex@netWindows.org> with contributions by Kevin Driver <kevin@netWindows.org> and Ted Shroyer. Removal the copyright notice/authorship information is forbiden. No other restrictions are placed on the use or modification of this script. See script source for usage notes.");
		stdout("To submit bug reports, patches, and feature requests, or to get latest version of this script, visit www.netWindows.org");
		stdout("Copyright 2000-2001 Alex Russell");
	}else if((textN == "cls")||(textN == "clear")){
		cls();
	}else if((textN == "ls")||(textN == "dir")){
		stdout("sorry, this isn't an operating system command line.");
		stdout('type "help" for more commands');
	}else{
		if(textN.charAt && textN.charAt(textN.length-1)!=";"){textN += ";";}
		cCommands = cCommands.concat([textN]);
		try{
			eval(textN);
			cCommandsArrowOffset=0;
			stdout(textN);
			cTextF.value = "";
		}catch(e){
			stdout('execuction of "'+textN+'" failed with the following errors:');
			stdout(e.name);
			stdout(e.message);
		}
	}
}

//fuction declarations

//this function will do the heavy lifting via DOM methods...
//  NOTE: since we aren't attaching event handlers, we don't really have to worry
//  about the funky way that IE5 needs handlers added to be able to reckognize 
//  them.

//some explination about the argurments:
/*
	ConsoleText
		the text that appears at the console when it is created
	xOffset
		the number of pixels (as an integer) that you would like the console
		offset in the direction specified by XAlign (either left or right, see below)
	yOffset
		the number of pixels (as an integer) that you would like the console
		offset in the direction specified by yAlign (either top or bottom, see below)
	xAlign
		a string, either "left" or "right", specifying which side of the screen
		the console should be aligned too
	yAlign
		a string, either "top" or "bottom", specifying which side of the screen
		the console should be aligned too in the y axis
	wide
		specifies, in pixels, the width of the console
	high
		specifies, in pixels, the desired height of the console
	opacity
		a whole number specifying the percentage that the console should be opaque.
*/
function create_console(ConsoleText, xOffset, yOffset, xAlign, yAlign, wide, high, opacity) {
	var wide = new String(wide);
	var high = new String(high);
	if(isCreated == false){
		if(parseInt(wide)>200){
		cTextF.style.width = (wide - 100) + "px";
		}else{cTextF.style.width = "100px";}

		var wide=new String(wide); //cast to string
		if(wide.charAt && wide.charAt(wide.length-1)!="%"){ //handle both percentages and pixels
			cRootElem.style.width = (wide + "px");
		}else{
			cRootElem.style.width = wide;
		}

		//  uncomment the next line if you want to keep your console a fixed "length"
		// cRootElem.style.overflow="visible";
		//  or if you want it to have a scrollbar...
		//cRootElem.style.overflow="auto";		
		
		/* EES III - Really want to have a scrollbar on the contents */
		/*         - not on the whole element.  height = 90% is a fair guess*/
		cOutput.style.overflow="auto";
		cOutput.style.width = "100%";
		cOutput.style.height = "90%";
						
		high=new String(high); //cast to string
		if(high.charAt && high.charAt(high.length-1)!="%"){
			cRootElem.style.height = (high + "px");
		}else{
			cRootElem.style.height = high;
		}
		
		cRootElem.style.border="2px solid black";
		cRootElem.style.backgroundColor="#f6f6f6";
		//cRootElem.setAttribute("__theme_definition", 'main_bgcolor: backgroundColor;');
		cRootElem.style.position="absolute";
		if(xAlign=="left"){
			cRootElem.style.left = (xOffset + "px");
		}else{
			cRootElem.style.right = (xOffset + "px");
		}
		if(yAlign=="top"){
			cRootElem.style.top = (yOffset + "px");
		}else{
			cRootElem.style.bottom = (yOffset + "px");
		}
		cRootElem.style.zIndex="1";
		//  these options are for those who want to play with opacity of their console
		//  the top one is for gecko, the second one for IE, they must be set in this order.
		cRootElem.style.MozOpacity=(opacity/100);
		cRootElem.style.filter = ("Alpha(Opacity="+opacity+")");
		cRootElem.id="console";
		
		//now that we've set some elements, let's add them to the page!
		var ConsoleNode = document.createTextNode("");
		//  this is probably the lazy man's way to do it, but it's foolproof.
		// ...alas, the world always seems to be building better fools...
		// perhaps in the future, a version of this function could take a node
		// reference to append the console too as an argument?
		document.body.appendChild(cRootElem);
		cRootElem.appendChild(cOutput);
		cOutput.appendChild(ConsoleNode);
		stdout(ConsoleText);
		isCreated = true;
		return true;
	}
	stdout('Sorry, only one console allowed!');
	return true;
}	

function create_console_win(){
	//window.open();
}

// our primary output method...pretty straighforward...
function stdout(cText) {
	return sstdout(cText, "black", "Courier New, Courier, sans-serif", "13px");
}

//stylized stdout function, takes display params, unlike regular stdout function
function sstdout(cText, pcolor, pfont, psize){
	var NewLine = document.createElement("div");
	with(NewLine.style){
		fontSize = psize;
		fontFamily = pfont;
		color = pcolor;
		borderTop = "1px #959595 solid";
	}
	var NewConsoleNode = document.createTextNode(cLineNo + " " + cText);
	cLineNo++;
	if(cOutputOrder=="append"){
		cOutput.appendChild(NewLine);
	}else{
		cOutput.insertBefore(NewLine, cOutput.firstChild);
	}
	NewLine.appendChild(NewConsoleNode);
	if(NewLine.scrollIntoView){
		NewLine.scrollIntoView(false);
	}
	return true;
}

// takes string of HTML as argument, uses non-standard innerHTML property, so it 
// will likely only work in IE and Mozilla
function stdoutHTML(htmlString, pcolor, pfont, psize){
	var NewLine = document.createElement("DIV");
	with(NewLine.style){
		fontSize = psize;
		fontFamily = pfont;
		color = pcolor;
		borderTop = "1px #959595 solid";
	}
	var NewConsoleNode = document.createTextNode(cLineNo + " ");
	cLineNo++;
	if(cOutputOrder=="append"){
		cOutput.appendChild(NewLine);
	}else{
		cOutput.insertBefore(NewLine, cOutput.firstChild);
	}
	NewLine.appendChild(NewConsoleNode);
	NewLine.innerHTML+=htmlString;
	return true;
}

function cls() {
	while (cOutput.hasChildNodes()){ cOutput.removeChild(cOutput.childNodes[0]);}
	cLineNo = 1;
	stdout("< < console cleared > >");
	return true;
}

if(window.__scripts__){
	__scripts__.finalize(__config__.corePath+"console.js");
}
