// $Id: data_core.js,v 1.15 2003/01/12 09:38:14 russcoon Exp $
// Copyright (c) 2000-2003 Alex Russell
// Licensed under the Academic Free License version 1.1

// Filename:		data_core.js
// Purpose:		a class and object for mediating data transfer via the content queue
// Classes:		NW_dataCore
// Global Objects:	__data__
// Dependencies:	component_registry.js

__scripts__.provide(__config__.corePath+"data_core.js");
__scripts__.require(__config__.corePath+"component_registry.js");

// data singleton core object
__data__ = new Object();

__data__.regArr = new Array();

__data__.tgtNode = document.createElement("div");
with(__data__.tgtNode.style){
	// display = "none";
	width = "1px";
	height = "1px";
}

__data__.addDataRcpt = function(dataRecpt){
	if(!this.regArr[dataRecpt.dataRcptName]){
		this.regArr[dataRecpt.dataRcptName]=dataRecpt;
		return true;
	}
	return false;
}

__data__.isValidRcpt = function(name){
	if(this.regArr[name]){return true;}else{return false;}
}

// dummy return class for the inline constructor mechanism
__data__.dummy_return = function(someCode){
	this.tgtNode = document.createElement("span"); // as good a place as any
	var tobj = new Object();
	tobj.domNode = document.createElement("div");
	tobj.domNode.innerHTML = someCode;
	return tobj;
}

var __NW_data__ = __data__;

function NW_dataCore_dispatch(domNode){
	if(!__env__.is_IE){// moz hack
		if(__data__.tgtNode.parentNode != document.body){
			document.body.appendChild(__data__.tgtNode);
		}
		with(__data__.tgtNode.style){
			width = (parseInt(width)+1)+"px";
			width = (parseInt(width)-1)+"px";
		}
	}
	/* 
	we need to kind of hack the parsing process to keep 
	from traversing nodes any more than is strictly necessaray
	*/
	var pProfile = "deep";
	if(__util__.hasAttr(domNode,"parseProfile")){
		pProfile = __util__.getAttr(domNode, "parseProfile");
	}
	if(pProfile=="deep"){
		var props = __util__.parseNWProps(domNode, ['dataRcptName']);
		var oName = null;
		if(props["dataRcptName"]){
			oName = props["dataRcptName"];
		}
		if(__data__.isValidRcpt(oName)){
			// delete props;
			var nprops = __util__.parseNWComponents(domNode, __data__.regArr[oName].attributes, __data__.regArr[oName].multiValued);
			__data__.regArr[oName].rcv(nprops);
		}
	}else if(pProfile=="shallow"){
		// we make some agressive assumptions for the sake of speed here
		// the first assumption is that the "dataRcptName" will be an 
		// attribute of the top level node
		var oName = __util__.getAttr(domNode, "dataRcptName");
		if(__data__.isValidRcpt(oName)){
			with(__data__.regArr[oName]){
				// next, we only parse the top level elements and nothing else
				rcv(__util__.parseNWProps(domNode, attributes, multiValued));
			}
		}
	}else if(pProfile=="eval"){
		// FIXME: dangerous as all hell but hopefully fast
		__data__.regArr[__util__.getAttr(domNode, "dataRcptName")].rcv(eval(domNode.innerHTML));
	}
	// __data__.tgtNode.innerHTML = "";
	return __data__.dummy_return("");
}

__widgets__.register("data", "NW_dataCore_dispatch", null);


// template for data receptor objects
// data receptor objects don't have to necessarialy subclass this class,
// they must however have a "name" property and a "rcv" function
function NW_dataRcptObj(pname){
	this.dataRcptName = pname; //unique name of data repos object
	this.attributes = new Array(); // an array of strings representing nwProperty types available to be parsed as attributes
	this.multiValued = new Array(); // a list of names of nwProperty types which can be multi-valued
	this.rcv = function(dataObj){stdout(dataObj); return true;} //should be overloaded by subclasses
}

__scripts__.finalize(__config__.corePath+"data_core.js");
