// $Id: sigslot_core.js,v 1.18 2003/01/20 23:54:08 russcoon Exp $
// Copyright (c) 2000-2003 Alex Russell
// Licensed under the Academic Free License version 1.1

// Filename:		sigslot_core.js
// Purpose:		provides event system for entire codebase
// Classes:		NW_sigslot_registry, NW_SignalObj
// Global Objects:	__sig__ (aka, __signals_registry__)
// Dependencies:	none

if(window.__scripts__){ __scripts__.provide(__config__.corePath+"sigslot_core.js"); }

// class definition for signal objects

// Function.apply() emulation from Aaron Boodman (www.youngpup.net). 
// Included by permission.
// impliment function apply for browsers which don't support it natively
if(typeof Function.prototype.apply == 'undefined'){
	Function.prototype.apply = function(oScope, args){
		var sarg = [];
		var rtrn, call;

		if (!oScope) oScope = window;
		if (!args) args = [];

		for (var i = 0; i < args.length; i++){
			sarg[i] = "args["+i+"]";
		}

		call = "oScope.__applyTemp__(" + sarg.join(",") + ");";

		oScope.__applyTemp__ = this;
		rtrn = eval(call);
		oScope.__applyTemp__ = null;
		return rtrn;
	};
}


function NW_SignalObj(obj, fp){
	this.fp = fp;
	this.obj = obj;
	this.slots = new Array();
	this.addSlot = function(pobj, pfp){
		var slot = null;
		if(__sig__.isSigFP(pfp)){
			slot = __sig__.getSig(pfp);
		}else{
			// whee! recursive data structures!
			slot = new NW_SignalObj(pobj, pfp);
			__sig__.addSig(slot);
		}
		this.slots[this.slots.length]=slot;
	}

	this.rmSlot = function(pobj, pfp){
		if(__sig__.isSigFP(pfp)){
			var tslot = __sig__.getSig(pfp);
			for(var x in this.slots){
				if(this.slots[x]==tslot){
					if(this.slots.length>0){
						// make sure we only remove the first instance
						delete this.slots[this.slots.length-1];
					}
					return true;
				}
			}
		}else{
			return false;
		}
	}
}

__sig__ = new Object();
__sig__.uID = 0;
// conArr contains an arry of signal objects
__sig__.connArr = new Array();

// this method provides the mapping between signals and slots
__sig__.connect = function(sigObj, sigFP, slotObj, slotFP){
	var isFound = this.isSigFP(sigFP);
	if(!isFound){
		this.addSig(new NW_SignalObj(sigObj, sigFP));
	}
	var csig = this.getSig(sigFP);
	csig.addSlot(slotObj, slotFP);
}

// this method provides the mapping between signals and slots
__sig__.disconnect = function(sigObj, sigFP, slotObj, slotFP){
	var csig = this.getSig(sigFP);
	csig.rmSlot(slotObj, slotFP);
}

__sig__.addBareSignal = function(sigObj, sigFP){
	this.addSig(new NW_SignalObj(sigObj, sigFP));
}
__sig__.addBareSig = __sig__.addBareSignal; //alias

__sig__.addSig = function(sigObj){
	var cUID = this.uID++;// should be atomic anyway, but make sure
	this.connArr[cUID]=sigObj;
}

__sig__.isSigFP = function(fp){
	var isFound = false;
	for(var x in this.connArr){ 
		if(this.connArr[x].fp == fp){
			isFound = true;
		}
	}
	return isFound;
}

__sig__.getSig = function(fp){
	for(var x in this.connArr){ 
		if(this.connArr[x].fp == fp){
			return this.connArr[x];
		}
	}
	return null;
}

__sig__.emit = function(fp){
	for(x in this.connArr){
		// find the signal object
		if(this.connArr[x].fp==fp){ 
			var csig = this.connArr[x];
			var alen = arguments.length;
			var tarr = new Array();
			// turn arguments pseudo-array into a true array, remoing the first element
			for(var x = 1; x<alen; x++){
				tarr[tarr.length]=arguments[x];
			}
			// FIXME: need to add arity check here!
			// call the current fp
			if(csig.fp){
				(csig.fp).apply(csig.obj, tarr);
			}
			for(y in csig.slots){
				// now call all slots registered on it
				if((csig.slots[y])&&(csig.slots[y].fp)){
					var ntarr = new Array(csig.slots[y].fp);
					ntarr = ntarr.concat(tarr);
					this.emit.apply(this, ntarr);
				}
			}
		}
	}
}

__signals_registry__ = __sig__; // alias

if(window.__scripts__){
	__scripts__.finalize(__config__.corePath+"sigslot_core.js");
}
