// $Id: footer_bar_widget.js,v 1.22 2003/01/24 16:33:09 russcoon Exp $
// Copyright (c) 2000-2002 Alex Russell
// Licensed under the Academic Free License version 1.1

// Filename:		header_bar_widget.js
// Purpose:			provide a definition file for the header-bar widget.
// Classes:			NW_WIDGET_header_bar
// Global Objects:	none
// Dependencies:	widget_core.js, theme_core.js, environ_core.js, component_registry.js

/*
	CSS classes for this widget:

		* FooterBar-drag-img
		* FooterBar-container-div
		* FooterBar-text-div
*/

with(__scripts__){
	provide(__config__.widgetPath+"footer_bar_widget.js");
	require(__config__.corePath+"widget_core.js");
	require(__config__.corePath+"environ_core.js");
	require(__config__.corePath+"utility_core.js");
}

function NW_WIDGET_footer_bar(domNode){
	this.parent = NW_widgetComponent;
	this.parent(domNode);
	delete this.parent;
	this.domNode = domNode;
	this.textNode = null;
	this.dragImg = null;
	this.isTopLevelComp = false;
	this.isDraggable = false;
	this.setText = NW_WIDGET_footer_bar_set_text;
	this.componentType = "footer_bar";
}
NW_WIDGET_footer_bar.prototype = new NW_widgetComponent; //deep inhertiance support
__widgets__.register("footer_bar", null, "NW_WIDGET_FACTORY_footer_bar");

function NW_WIDGET_footer_bar_set_text(textString){ this.textNode.innerHTML=textString; }

////////////////////////////// WIDGET FACTORY //////////////////////////////////
function NW_WIDGET_FACTORY_footer_bar(parentIdNum){
	var barHeight = 20;
	var bdnmkr = new NW_element_maker_obj("div");
	var bdn = bdnmkr.getElement();
	__util__.setClass(bdn, "FooterBar-container-div");
	if(__env__.is_IE){
		//IE weirdness
		bdn.style.position = "absolute";
	}
	BarStyleStr = "align:right; width:100%; height:"+ barHeight+"px; left:2px; bottom:2px; cursor:default; borderStyle:inset; borderWidth:1px/1px/1px/1px;";
	__util__.setNodeStyle(BarStyleStr, bdn);
	__theme__.setStyleByAttr(bdn, "main_bgcolor", "backgroundColor");
	__theme__.setStyleByAttr(bdn, "main_bgcolor", "borderColor");
	bdn.setAttribute("theme", "borderColor:main_border_color;backgroundColor:main_bgcolor;");

	var tdnmkr = new NW_element_maker_obj("div");
	var tTDN = tdnmkr.getElement(); 
	__util__.setClass(tTDN, "FooterBar-text-div");
	__theme__.setStyleByAttr(tTDN, "head_bar_font_size", "fontSize");
	__theme__.setStyleByAttr(tTDN, "head_bar_font_family", "fontFamily");
	with(tTDN.style){
		position = "absolute";
		padding = "2px 4px";
		height = "15px";
		overflow = "hidden";
	}

	bdn.appendChild(tTDN);

	var tinmkr = new NW_element_maker_obj("img");
	var tin = tinmkr.getElement();
	__util__.setClass(tin, "FooterBar-drag-img");
	__theme__.setStyleByAttr(tin, "main_border_color", "borderColor");
	with(tin.style){
		// fix for mozilla trying to drag the image
		if(!__env__.is_IE){
			position = "relative";
		}
		align = "right";
		top = "3px";
		width = height = "15px";
		cursor = "move";
		right = "1px";
		borderStyle = "inset";
		borderWidth = "0px 1px 1px 0px";
	}
	with(tin){
		setAttribute("align", "right");
		align = "right";
		setAttribute("border", "0");
		setAttribute("hspace", "0");
		setAttribute("vspace", "1");
		setAttribute("resize", "true");
		// FIXME: do we need this explicit attribute setting? Dissabling for now.
		// setAttribute("theme", "borderColor:main_border_color;");
		src = __theme__.getThemeAttr("window_drag_image");
	}

	bdn.appendChild(tin);

	var footerBarObj = new NW_WIDGET_footer_bar(bdn);	
	footerBarObj.textNode = tTDN;
	footerBarObj.dragImg = tin;
	bdn.setAttribute("NW_compID", footerBarObj.globIdNum);
	bdn.id = footerBarObj.globIdNum;
	return footerBarObj;
}
__scripts__.finalize(__config__.widgetPath+"footer_bar_widget.js");
