// $Id: menu_bar_widget.js,v 1.33 2003/01/15 06:50:26 russcoon Exp $
// Copyright (c) 2000-2002 Alex Russell
// Licensed under the Academic Free License version 1.1

// Filename:		menu_bar_widget.js
// Purpose:		define the menu_bar factory, the widget is secondary.
// Classes:		NW_WIDGET_menu
// Global Objects:	none
// Dependencies:	widget_core.js, theme_core.js, environ_core.js, component_registry.js

/*
	CSS classes for this widget:

		* MenuBar-top-div

*/

with(__scripts__){
	provide(__config__.widgetPath+"menu_bar_widget.js");
	require(__config__.corePath+"widget_core.js");
	require(__config__.corePath+"environ_core.js");
	require(__config__.widgetPath+"menu_widget.js");
}

function NW_WIDGET_menu_bar_state_obj(){
	this.isAMenuVisible = false;
	this.currentMenuSrc = null;
}

function NW_WIDGET_menu_bar(domNode){
 	this.parent = NW_widgetComponent;
	this.parent(domNode);
	delete this.parent;
	this.domNode = domNode;
	this.isTopLevelComp = false;
	this.isDraggable = false;
	this.componentType = "menu_bar";
	this.currTargetComp = null;
	this.menuDown = false;

	// slots for listening to signals set on the member menus

	this.highlightListener = function(nd, compRef){ 
		if(compRef!=this.currTargetComp){
			if(this.menuDown){
				if(compRef&&compRef.showMenu){
					compRef.showMenu(null);
					compRef.highlight();
					this.currTargetComp.hideMenu();
					this.currTargetComp.unHighlight();
				}
			}
		}
		if(compRef){
			this.currTargetComp = compRef;
		}
	}

	this.unHighlightListener = function(nd, compRef){ 
	}

	this.showMenuListener = function(nd, compRef){ 
		this.menuDown = true;
		this.currTargetComp = compRef;
	}

	this.hideMenuListener = function(nd, compRef){ 
		if(compRef == this.currTargetComp){
			this.menuDown = false;
		}
		this.currTargetComp = null;
	}
}
NW_WIDGET_menu_bar.prototype = new NW_widgetComponent; //deep inhertiance support
//we only define an inline constructor for the menu bar
__widgets__.register("menu_bar", "NW_WIDGET_FACTORY_menu_bar", null);

function NW_WIDGET_menu_bar_unsel_all(){
	var myInt = __components__.regArr.length;
	for(var i = 0; i<myInt; i++){
		if(__components__.regArr[i]){
			if(__components__.regArr[i].componentType == "menu_bar"){
				__components__.regArr[i].currTargetComp = null;
			}
		}
	}
}
__sig__.connect(__env__, __env__.onMouseUp, null, NW_WIDGET_menu_bar_unsel_all);

function NW_WIDGET_FACTORY_menu_bar(sourceNode){
	var bFactory = new NW_element_maker_obj("div");
	bFactory.setEvent("onMouseUp","__util__.cancelEvent(event);");
	dNode = bFactory.getElement();
	__util__.setClass(dNode, "MenuBar-top-div");
	with(__theme__){
		setStyleByAttr(dNode, "menu_border_color", "borderColor");
		setStyleByAttr(dNode, "menu_bgcolor", "backgroundColor");
		setStyleByAttr(dNode, "menu_font_size", "fontSize");
	}
	with(dNode.style){
		borderWidth = "1px 1px 1px 1px";
		borderStyle = "inset";
		position = "relative";
		zIndex = "1";
		height = "20px";
		left = "0px";
		top = "0px";
		cursor = "default";
		overflow = "visible";
		width = "100%";
	}
	var barObj = new NW_WIDGET_menu_bar(dNode);	
	dNode.setAttribute("NW_compID", barObj.globIdNum);

	if(!__env__.is_IE){ sourceNode = __util__.stripWS(sourceNode);}
	if((__env__.is_IE)&&(__env__.is_mac)){ sourceNode = __util__.stripWS(sourceNode);}
	var cnLen = sourceNode.childNodes.length;
	var i = 0;
	var accumWidth = 0;
	// using do-while since for loop makes things break
	do{
		var retobj = NW_WIDGET_FACTORY_menu_bar_help(barObj.domNode, sourceNode.childNodes[i], accumWidth);
		// hook up signals and slots
		with(__sig__){
			connect(retobj, retobj.highlight, barObj, barObj.highlightListener);
			connect(retobj, retobj.unHighlight, barObj, barObj.unHighlightListener);
			connect(retobj, retobj.showMenu, barObj, barObj.showMenuListener);
			connect(retobj, retobj.hideMenu, barObj, barObj.hideMenuListener);
		}
		accumWidth += parseInt(retobj.buttonWidth);
		i++;
	}while(i < cnLen)
	return barObj;
}

function NW_WIDGET_FACTORY_menu_bar_help(node1, node2, accumLeft){
	var tempObj = NW_WIDGET_FACTORY_menu(node2);
	tempObj.domNode.style.left = accumLeft + "px";
	node1.appendChild(tempObj.domNode);
	return tempObj;
}

__scripts__.finalize(__config__.widgetPath+"menu_bar_widget.js");
