// $Id: menu_widget.js,v 1.58 2002/11/09 17:33:50 russcoon Exp $
// Copyright (c) 2000-2002 Alex Russell
// Licensed under the Academic Free License version 1.1

// Filename:		menu_widget.js
// Purpose:		provide a definition file for the content area widget.
// Classes:		NW_WIDGET_menu
// Global Objects:	none
// Dependencies:	widget_core.js, theme_core.js, environ_core.js, component_registry.js

__scripts__.provide(__config__.widgetPath+"menu_widget.js");
__scripts__.require(__config__.corePath+"widget_core.js");

function NW_WIDGET_menu(domNode){
 	this.parent = NW_widgetComponent;
	this.parent(domNode);
	delete this.parent;
	this.domNode = domNode;
	this.buttonWidth = null;
	this.isTopLevelComp = false;
	this.isDraggable = false;
	this.componentType = "menu";
	
	//menu specific stuff...
	this.isMenuVisible = false;
	this.isHL = false;
	this.isBeveled = false;
	this.menuComponent = null;

	this.showMenu = function(nd){
		if(this.isMenuVisible == false){
			this.isMenuVisible = true;
			this.menuComponent.show();
		}else if(this.isMenuVisible == true){
			__sig__.emit(this.hideMenu);
			// NW_WIDGET_menu_hide_all_menus();
			this.isMenuVisible = false;
		}
	}

	this.hideMenu = function(){
		if(this.isMenuVisible){
			this.isMenuVisible = false;
			this.menuComponent.hide();
		}
	}

	this.highlight = function(){
		if(this.isMenuVisible){
			this.domNode.style.borderStyle = "inset";
		}else{
			this.domNode.style.borderStyle = "outset";
		}
		this.domNode.style.borderWidth = "1px 2px 1px 2px";
		this.domNode.style.padding = "0px 4px 0px 4px";
	}

	this.unHighlight = function(){
		if(!this.isMenuVisible){
			this.domNode.style.borderStyle = 'none none none none';
			this.domNode.style.padding = "1px 6px 1px 6px";
		}
	}

	__sig__.addBareSig(this, this.showMenu);
	__sig__.addBareSig(this, this.hideMenu);
	__sig__.addBareSig(this, this.highlight);
	__sig__.addBareSig(this, this.unHighlight);

}
NW_WIDGET_menu.prototype = new NW_widgetComponent; //deep inhertiance support
__widgets__.register("menu", "NW_WIDGET_FACTORY_menu", null);



// the menu component widget
function NW_WIDGET_menu_component(domNode){
	//make the menu_comp a widget...
 	this.parent = NW_widgetComponent;
	this.parent(domNode);
	delete this.parent;
	this.domNode = domNode;
	this.isTopLevelComp = false;
	this.isDraggable = false;
	this.componentType = "menu_comp";
	
	// menu comp data
	this.width = 0;
	this.elementHeight = 16;
	this.visibleChild = null;
	this.menuNodes = new Array();
	this.addNode = NW_WIDGET_menu_comp_add_node;

	this.show = function(){
		this.domNode.style.display = "block";
		this.domNode.style.visiblity = "visible";
	}

	this.hide = function(){
		this.hideChildren();
		this.domNode.style.display = "none";
		this.domNode.style.visiblity = "hidden";
	}

	this.generate = function(isTopLevel, par, top){
		var mFctry = new NW_element_maker_obj("div");
		mFctry.setEvent("onMouseOver","__util__.cancelEvent(event);");
		if(!__env__.is_IE){
			mFctry.setEvent("onMouseOut", "__util__.cancelEvent(event);");
		}
		this.domNode = mFctry.getElement();
		with(__theme__){
			setStyleByAttr(this.domNode, "menu_bgcolor", "backgroundColor");
			setStyleByAttr(this.domNode, "menu_border_color", "borderColor");
			setStyleByAttr(this.domNode, "menu_font_color", "color");
		}
		with(this.domNode.style){
			borderStyle = "outset";
			borderWidth = "1px 1px 1px 1px";
			position = "absolute";
			zIndex = "1000";
			width = this.width+"px";
		}
		this.domNode.setAttribute("NW_compID", this.globIdNum);
		if(isTopLevel == true){
			this.domNode.style.top = parseInt(top) + "px";
			this.domNode.style.left = "0px";
		}else{
			if(!__env__.is_IE){
				this.domNode.style.top = parseInt(top) + "px";
			}else{
				this.domNode.style.top = parseInt(top) + "px";
			}
			this.domNode.style.left = (par.domNode.style.width);
		}

		//***************************************
		// create the individual list members....
		var subImg = document.createElement("img");
		with(subImg){
			src = __config__.NWroot+"images/sub_menu.png";
			setAttribute('border','0');
			setAttribute('align','right');
			setAttribute('height','8');
			setAttribute('width','8');
			setAttribute('vspace','2');
		}
		
		var cnode = "__components__.getComponentFromNode(this.parentNode)";
		for(var i=0; i<this.menuNodes.length; i++){
			mFctry = new NW_element_maker_obj("div");
			with(mFctry){
				setEvent("onMouseOver","NW_WIDGET_menu_highlight(this);");
				setEvent("onMouseOver", cnode+".hideChildren();");
				if(this.menuNodes[i].childCompID != null){
					setEvent("onMouseOver", cnode+".showChild('"+this.menuNodes[i].childCompID+"');");
				}

				setEvent("onMouseOver","__util__.cancelEvent(event);");
				setEvent("onMouseOut","NW_WIDGET_menu_unHighlight(this);");
				setEvent("onMouseOut","__util__.cancelEvent(event);");
				setEvent("onMouseDown",this.menuNodes[i].action);  
				var dNode = getElement();
			}

			with(__theme__){
				setStyleByAttr(dNode, "menu_font_size", "fontSize");
				setStyleByAttr(dNode, "menu_font_color", "color");
				setStyleByAttr(dNode, "menu_border_style", "borderStyle");
				setStyleByAttr(dNode, "menu_border_color", "borderColor");
				setStyleByAttr(dNode, "menu_bgcolor", "backgroundColor");
			}
			with(dNode.style){
				borderWidth = "1px";
				fontFamily = "Arial, Helvetica, sans-serif";
				zIndex = "1000";
				padding = "0px 4px 0px 4px";
				textDecoration = "none";
			}
			if(this.menuNodes[i].childCompID != null){
				dNode.appendChild(subImg);
			}
			dNode.innerHTML += this.menuNodes[i].dispText;
			this.domNode.appendChild(dNode);
		}
		return this.domNode;
	}

	this.showChild = function(childID){
		if(this.visibleChild != null){
			this.visibleChild.hide();
			this.visibleChild = null;
		}
		this.visibleChild = __components__.getComponent(childID);
		this.visibleChild.show();
	}

	this.hideChildren = function(){
		if(this.visibleChild != null){
			this.visibleChild.hide();
			this.visibleChild = null;
		}
	}

}
__widgets__.register("menu_comp", null, null);

function NW_WIDGET_menu_comp_add_node(nodeObj){
	this.menuNodes[this.menuNodes.length]=nodeObj;
}

// it should always be this easy...iterate, match, call...done...that simple...
function NW_WIDGET_menu_hide_all_menus(){
	var myInt = __components__.regArr.length;
	for(var i = 0; i<myInt; i++){
		if(__components__.regArr[i]){
			var tc = __components__.regArr[i];
			// if((tc.componentType == "menu")&&(tc.isMenuVisible)){
			if(tc.componentType == "menu"){
				__sig__.emit(tc.hideMenu, tc);
				__sig__.emit(tc.unHighlight, tc);
			}
		}
	}
}

__sig__.connect(__env__, __env__.onMouseUp, null, NW_WIDGET_menu_hide_all_menus);

// data structure node
function NW_WIDGET_menu_node(){
	this.action = null;
	this.dispText = null;
	this.childCompID = null;
}

// fuctions for doing stuff like highlighting a menu item and showing components
function NW_WIDGET_menu_highlight(dn){
	dn.style.backgroundColor = __theme__.getAttr("menu_hl_bgcolor");
	dn.style.color = __theme__.getAttr("menu_hl_font_color");
}

function NW_WIDGET_menu_unHighlight(dn){
	dn.style.backgroundColor = __theme__.getAttr("menu_bgcolor");
	dn.style.color = __theme__.getAttr("menu_font_color");
}

////////////////////////////// WIDGET FACTORY //////////////////////////////////
function NW_WIDGET_FACTORY_menu(domNode){
	var mFctry = new NW_element_maker_obj("div");
	var gcfnstr = "__components__.getComponentFromNode(this)";
	mFctry.setEvent("onClick","var tc = "+gcfnstr+"; __sig__.emit(tc.showMenu, __util__.evtTarget(event), tc); __sig__.emit(tc.highlight, tc);");
	mFctry.setEvent("onMouseOver","var tc = "+gcfnstr+"; __sig__.emit(tc.highlight, __util__.evtTarget(event), tc);");
	mFctry.setEvent("onMouseOut","var tc = "+gcfnstr+"; __sig__.emit(tc.unHighlight, __util__.evtTarget(event), tc);");
	// mFctry.setEvent("onMouseUp","__util__.cancelEvent(event);");
	var dNode = mFctry.getElement();

	with(__theme__){
		setStyleByAttr(dNode, "menu_font_size", "fontSize");
		setStyleByAttr(dNode, "menu_font_color", "color");
		setStyleByAttr(dNode, "menu_bgcolor", "backgroundColor");
	}
	with(dNode.style){
		position = "absolute";
		zIndex = "1000";
		height = "18px";
		top = "0px";
		cursor = "default";
		overflow = "visible";
		padding = "1px 5px 1px 5px";
	}
	//now, before we get too far along in this...let's make our object...
	var contentObj = new NW_WIDGET_menu(dNode);	
	NW_WIDGET_FACTORY_menu_parser(domNode, contentObj);
	dNode.setAttribute("NW_compID", contentObj.globIdNum);
	return contentObj;
}

// fetch data from DOM node
function NW_WIDGET_FACTORY_menu_parser(domNode, menuObj){
	var attrArr = ['width', 'dispText', 'action', 'link'];
	var dataObj = __util__.parseNWComponents(domNode, attrArr);
	menuObj.domNode.appendChild(document.createTextNode(dataObj["dispText"]));
	menuObj.buttonWidth = dataObj["width"];

	for(var x in dataObj["nwComponents"]["menuComponent"]){
		menuObj.menuComponent = NW_WIDGET_FACTORY_menu_parse_component(dataObj["nwComponents"]["menuComponent"][x], true, 20, null);
		menuObj.domNode.appendChild(menuObj.menuComponent.domNode);
	}
}

function NW_WIDGET_FACTORY_menu_parse_component(dataObj, isTL, topVal, parent){
	var mFctry = new NW_element_maker_obj("div");
	mFctry.setEvent("onClick","__util__.cancelEvent(event);");

	var dNode = mFctry.getElement();
	var currComp = new NW_WIDGET_menu_component(dNode);
	currComp.width = parseInt(dataObj["width"]);

	var smallre = /<a\ /g;
	var bigre = /<A\ /g;
	var rep = "<a style='text-decoration: none; color: black;' ";
	var count = 0;
	var children = new Array();
	for(var i in dataObj["nwComponents"]["menuNode"]){
		var cdata = dataObj["nwComponents"]["menuNode"][i];
		var tempNode = new NW_WIDGET_menu_node();
		if(cdata["link"]){
			var lt =  new String(cdata["link"]);
			lt = lt.replace(smallre,rep);
			lt = lt.replace(bigre,rep);
			var loc  = lt.match(/http:\/\/.*\"/)[0];
			loc = loc.slice(0, -1);
			tempNode.action = "window.location='"+loc+"';";
			tempNode.dispText = lt;
		}else{
			tempNode.dispText = cdata["dispText"];
			if(cdata["action"]){
				tempNode.action = cdata["action"];
			}else{
				tempNode.action = "return true;";
			}
		}
		if((cdata["nwComponents"])&&(cdata["nwComponents"]["menuComponent"])){
			var objRef = NW_WIDGET_FACTORY_menu_parse_component(cdata["nwComponents"]["menuComponent"][0], false, ((currComp.elementHeight*count)-5), currComp);
			children[children.length] = objRef;
			tempNode.childCompID = objRef.globIdNum;
		}
		currComp.addNode(tempNode);
		count++;
	}
	currComp.generate(isTL, parent, topVal);
	for(var y in children){
		currComp.domNode.appendChild(children[y].domNode);
		children[y].domNode.style.left = currComp.domNode.style.width;
	}
	currComp.hide();
	return currComp;
}

__scripts__.finalize(__config__.widgetPath+"menu_widget.js");
