// $Id: sort_data_table_widget.js,v 1.39 2003/02/22 05:26:38 russcoon Exp $
// Copyright (c) 2000-2002 Alex Russell
// Licensed under the Academic Free License version 1.1

// Filename:		sort_data_table_widget.js
// Purpose:		sorts a table, doesn't do anything else.
// Classes:		NW_WIDGET_sort_data_table
// Global Objects:	none
// Dependencies:	widget_core.js, theme_core.js, environ_core.js, component_registry.js, utility_core.js

// FIXME: need to add sortAscending for on-placment defatult sort
with(__scripts__){
	var wcp = __config__.corePath;
	provide(__config__.widgetPath+"sort_data_table_widget.js");
	require(wcp+"utility_core.js");
	require(wcp+"widget_core.js");
	require(wcp+"theme_core.js");
	require(wcp+"environ_core.js");
	require(wcp+"component_registry.js");
	delete wcp;
}

function NW_WIDGET_sort_data_table(domNode){
 	this.parent = NW_widgetComponent;
	this.parent(domNode);
	delete this.parent;
	this.thead = null;
	this.tbody = null;
	this.columns = [];
	this.rows = [];
	this.sortOnLoad = false;
	this.onLoadSortColumn = null;
	this.onLoadSortAscending = false;
	this.isTopLevelComp = false;
	this.isDraggable = false;
	this.componentType = "sort_data_table";
	this.sortedColumn = null;
	this.sortEnabled = true;
	this.incomparableOrder = "last";
	this.sortReversed = false;
	this.upImgSrc = __config__.imgPath+"up_sort.png";
	this.downImgSrc = __config__.imgPath+"down_sort.png";
	this.sorts = __util__.sorts;
	this.sortImgNode = null;

	this.lookupColumnIndex = function(node){
		for(var x=0; x < this.columns.length; x++){
			if(this.columns[x]==node){
				return x;
			}
		}
		return null;
	}

	this.sortColumnFromEvent = function(evt){
		var tt = __util__.evtTarget(evt);
		var tobj = __components__.getComponentFromNode(tt);
		var ttnn = tt.nodeName.toUpperCase();
		while((ttnn != "TD")&&(ttnn != "TH")){
			if(ttnn == "BODY"){
				return false;
			}
			tt = tt.parentNode;
			ttnn = tt.nodeName.toUpperCase();
		}
		tobj.sortColumn(tt);
	}

	this.addRow = function(key, trref){
		var tlen = this.rows.length;
		trref.setAttribute("NW_table_key", key);
		var tc = trref.getElementsByTagName("td");
		this.rows[tlen] = trref.getElementsByTagName("td");
		this.rows[tlen]["tr"]=trref;
		this.rows[tlen]["key"]=key;
	}

	this.doOnPlacement = function(){
		var lse = this.sortEnabled;
		this.sortEnabled = true;
		if(this.sortOnLoad){
			if(this.onLoadSortColumn != null){
				var cdn = this.columns[this.onLoadSortColumn];
				if(this.onLoadSortAscending){
					this.sortReversed = false;
					this.sortedColumn = this.onLoadSortColumn;
				}
				this.sortColumn(cdn);
			}
		}
		this.sortEnabled = lse;
	}

	var reo = new RegExp("<.*?>","gm");
	this.tagRE = reo.compile("<.*?>","gm");
	var reo = new RegExp("^(&nbsp\;|&#160\;|\s|\n|\r)*","gm");
	this.lsRE = reo.compile("^(&nbsp\;|&#160\;|\s|\n|\r)*","gm");
	var reo = new RegExp("((&nbsp\;|&#160\;|\s|\n|\r)*)?$","gm");
	this.tsRE = reo.compile("((&nbsp\;|&#160\;|\s|\n|\r)*)?$","gm");
	var reo = new RegExp("(\t|&nbsp\;|&#160\;|\s|\r|\n)+","gm");
	this.wsRE = reo.compile("(\t|&nbsp\;|&#160\;|\s|\r|\n)+","gm");

	this.stripForSort = function(str){
		// get rid of HTML
		str = str.replace(this.tagRE,"");
		// remove leading spaces
		str = str.replace(this.lsRE,"");
		// remove trailing spaces
		str = str.replace(this.tsRE,"");
		// replace tabs and other whitespace with a single space
		str = str.replace(this.wsRE,"");
		return str;

	}

	this.sortColumn = function(domNode){
		if(!this.sortEnabled){
			return 1;
		}

		// this.domNode.style.display = "none";
		// FIXME: need to add support for custom comparitors here
		var sortType = __util__.getAttr(domNode,"sortComparator");
		var compareFunc = null;
		var convertFunc = null;
		if (sortType != null) {
			// FIXME: should do validity check that one of these exists
			compareFunc = this.sorts[sortType];
			convertFunc = __util__.converters[sortType];
		}

		// find the column we want to sort
		var col = this.lookupColumnIndex(domNode);
		var data = new Array();
		var blanks = new Array();
		var key_data = new Array();
		// this first step here is to get associatve arrays of keys and values
		var reo = new RegExp("(&nbsp\;|&#160\;|\n|\r|\s)*","gm");
		var ewsRE = reo.compile("(&nbsp\;|&#160\;|\n|\r|\s)*","gm");
		for(x in this.rows){
			var rtref = this.rows[x]["tr"];
			var tds = rtref.getElementsByTagName("td");
			if((col==null)||(!rtref.childNodes)||(col>=tds.length)||(!tds[col])){
				var ihtml = "";
			}else{
				var ihtml = this.stripForSort(tds[col].innerHTML||"");
			}
			var strippedIhtml = ihtml.replace(ewsRE,"");
			if((strippedIhtml=="")||(ihtml=="&nbsp;")||((ihtml.length==1)&&(ihtml[0]==" "))){
				blanks[blanks.length]=ihtml;
			}else{
				// FIXME: should catch thrown conversion errors, NaN, Undefined and put with blanks or something
				if(convertFunc != null) ihtml = convertFunc(ihtml);
				data[data.length]= ihtml;
			}
			if(key_data[ihtml]==null){
				// create a new bucket
				key_data[ihtml] = new Array(this.rows[x]["key"], x);
			}else{
				// add another index to the bucket
				key_data[ihtml][key_data[ihtml].length]=x;
			}
		}

		if(compareFunc != null){
			data.sort(compareFunc);
		}else{
			data.sort();
		}

		if((col == this.sortedColumn)&&(this.sortReversed==false)){
			this.sortReversed = true;
		}else{
			this.sortReversed = false;
			data.reverse();
		}
		if(this.incomparableOrder == "last"){
			data = data.concat(blanks);
		}else if(this.incomparableOrder == "first"){
			data = blanks.concat(data);
		}else if(this.incomparableOrder == "highest"){
			// stdout('highest!');
			if(this.sortReversed){
				// blanks = blanks.reverse();
				data = data.concat(blanks);
			}else{
				data = blanks.concat(data);
			}
		}else if(this.incomparableOrder == "lowest"){
			if(this.sortReversed){
				data = blanks.concat(data);
			}else{
				data = data.concat(blanks);
			}
		}else{
			data = data.concat(blanks);
		}

		this.reArrangeTableNodes(data, key_data);
		this.setSortImg(col);
		// this.domNode.style.display = "inline";

		delete data;
		delete key_data;
		return true;
	}

	this.setSortImg = function(colNo){
		if(this.sortImgNode != null){
			this.columns[this.sortedColumn].removeChild(this.sortImgNode);
			this.sortImgNode = null;
		}
		this.sortedColumn = colNo;

		var simgMkr = new NW_element_maker_obj("img");
		this.sortImgNode = simgMkr.getElement();
		with(this.sortImgNode){
			style.display = "inline";
			style.paddingTop = "3px";
			style.paddingLeft = "3px";
			style.paddingRight = "3px";
			if(this.sortReversed){
				src = this.upImgSrc;
			}else{
				src = this.downImgSrc;
			}
		}
		this.columns[this.sortedColumn].appendChild(this.sortImgNode);
	}

	this.reArrangeTableNodes = function(sortedData, key_data){
		// now re-order our display to reflect the new arrangement
		var data = sortedData;
		// var subsorted = [];
		var count = 0;
		for(x in data){
			var kdr = key_data[data[x]];
			var rows_index = kdr[kdr.length-1];
			var trref = this.rows[rows_index]["tr"];
			this.tbody.appendChild(trref);
			if(kdr.length>1){
				kdr.length = kdr.length-1;
			}
		}

	}


}
NW_WIDGET_sort_data_table.prototype = new NW_widgetComponent; //deep inhertiance support
__widgets__.register("sort_data_table", "NW_WIDGET_FACTORY_inline_sort_data_table", "NW_WIDGET_FACTORY_sort_data_table");

function NW_WIDGET_FACTORY_sort_data_table(tableNode){
	var thead = tableNode.getElementsByTagName("thead");
	var tbody = tableNode.getElementsByTagName("tbody");

	// we INSIST that we receive a well-formed table as input
	if((!tableNode.nodeName.toUpperCase()=="TABLE")&&
		(thead.length>0)&&(tbody.length>0)){
		return null;
	}else{
		thead = thead[0];
		tbody = tbody[0];
	}

	// create object
	var sto = new NW_WIDGET_sort_data_table(tableNode);
	tableNode.setAttribute("NW_compID", sto.globIdNum);
	tableNode.id = sto.globIdNum;

	// link table sections to object
	sto.thead = thead;
	sto.tbody = tbody;

	// register and link columns
	var ttds = sto.thead.getElementsByTagName("th");
	if(ttds.length == 0){
		ttds = sto.thead.getElementsByTagName("td");
	}
	sto.columns = ttds;
	for(var x=0; x<sto.columns.length; x++){
		var tc = sto.columns[x];
		__env__.addNodeEvtHdlr(tc, "click", sto.sortColumnFromEvent, false);
	}

	return sto;
}

function NW_WIDGET_FACTORY_inline_sort_data_table(domNode){
	var attrArr = [ 'sortOrder', 'sortComparator', 'columnName', 
			'upArrowImage', 'downArrowImage', 'sortEnabled', 
			'sortOnLoad', 'key', 'sortAscending', 
			'sortBlankAs' ];
	var parseObj = __util__.parseNWComponents(domNode, attrArr);
	var widgetObj = NW_WIDGET_FACTORY_sort_data_table(domNode);

	if(parseObj["upArrowImage"]){
		widgetObj.upImgSrc = parseObj["upArrowImage"];
	}

	if(parseObj["downArrowImage"]){
		widgetObj.downImgSrc = parseObj["downArrowImage"];
	}

	if(parseObj["sortBlankAs"]){
		// FIXME: need to add check for type. We support "first", "last", "lowest", and "highest".
		widgetObj.incomparableOrder= parseObj["sortBlankAs"];
	}

	// add the rows
	var drs = domNode.getElementsByTagName("tbody")[0].getElementsByTagName("tr");
	var ctr = 0;
	for(var x = 0; x < drs.length; x++){
		var crow = drs[x];
		if(crow.normalize){
			crow.normalize();
		}else{
			crow = __util__.stripWS(crow);
		}
		var targs = [ctr];
		if(__util__.hasAttr(crow,"key")){
			targs[0] = [__util__.getAttr(crow,"key")];
		}
		targs[1] = crow;
		widgetObj.addRow.apply(widgetObj, targs); 
		ctr++;
	}

	if((parseObj["sortOnLoad"])&&(parseObj["sortOnLoad"]=="true")){
		// FIXME: need to make this respect sort order prefs other than "0"
		widgetObj.sortOnLoad = true;
		for(var y = 0; y < widgetObj.columns.length; y++){
			var cn = widgetObj.columns[y];
			var tso = __util__.getAttr(cn, "sortOrder");
			if(!tso){
				tso = cn.getAttribute("sortOrder");
			}
			if(parseInt(tso)==0){
				widgetObj.onLoadSortColumn = y;
				var sa = __util__.getAttr(cn, "sortAscending");
				if((sa!=null)&&(sa=="true")){
					widgetObj.onLoadSortAscending = true;
				}
			}
		}
	}

	if((parseObj["sortEnabled"])&&(parseObj["sortEnabled"]=="false")){
		widgetObj.sortEnabled = false;
	}

	return widgetObj;
}

__scripts__.finalize(__config__.widgetPath+"sort_data_table_widget.js");
