// $Id: tool_bar_widget.js,v 1.7 2003/03/05 07:21:03 russcoon Exp $
// Copyright (c) 2000-2002 Alex Russell
// Licensed under the Academic Free License version 1.1

// Filename:		tool_bar_widget.js
// Purpose:		define the tool_bar widget and factories
// Classes:		NW_WIDGET_tool_bar
// Global Objects:	none
// Dependencies:	widget_core.js, theme_core.js, environ_core.js, component_registry.js

with(__scripts__){
	provide(__config__.widgetPath+"tool_bar_widget.js");
	require(__config__.corePath+"widget_core.js");
	require(__config__.corePath+"environ_core.js");
	require(__config__.corePath+"component_registry.js");
}

function NW_WIDGET_tool_bar(domNode){
 	this.parent = NW_widgetComponent;
	this.parent(domNode);
	delete this.parent;
	this.domNode = domNode;
	this.isTopLevelComp = false;
	this.isDraggable = false;
	this.componentType = "tool_bar";
}
NW_WIDGET_tool_bar.prototype = new NW_widgetComponent; //deep inhertiance support
__widgets__.register("tool_bar", "NW_WIDGET_INLINE_FACTORY_tool_bar", "NW_WIDGET_FACTORY_tool_bar");

function NW_WIDGET_FACTORY_tool_bar(){
	var bFactory = new NW_element_maker_obj("div");
	dNode = bFactory.getElement();
	with(__theme__){
		setStyleByAttr(dNode, "menu_border_color", "borderColor");
		setStyleByAttr(dNode, "menu_bgcolor", "backgroundColor");
		setStyleByAttr(dNode, "menu_font_size", "fontSize");
	}
	with(dNode.style){
		borderWidth = "1px 1px 1px 1px";
		borderStyle = "inset";
		position = "relative";
		zIndex = "1";
		height = "20px";
		left = "0px";
		// top = "20px"; // we really need to fix this
		cursor = "default";
		overflow = "visible";
		width = "100%";
	}
	var barObj = new NW_WIDGET_tool_bar(dNode);	
	dNode.setAttribute("NW_compID", barObj.globIdNum);
	return barObj;
}

function NW_WIDGET_INLINE_FACTORY_tool_bar(sourceNode){
	var barObj = NW_WIDGET_FACTORY_tool_bar();
	if(!__env__.is_IE){
		sourceNode = __util__.stripWS(sourceNode);
	}
	if((__env__.is_IE)&&(__env__.is_mac)){
		sourceNode = __util__.stripWS(sourceNode);
	}
	var cnLen = sourceNode.childNodes.length;
	var i = 0;
	var accumWidth = 0;
	// using do-while since for loop makes things break
	do{
		accumWidth += parseInt(NW_WIDGET_FACTORY_tool_bar_help(barObj.domNode, sourceNode.childNodes[i], accumWidth));
		i++;
	}while(i < cnLen)
	return barObj;
}

function NW_WIDGET_FACTORY_tool_bar_help(node1, node2, accumLeft){
	var tempObj = NW_WIDGET_INLINE_FACTORY_button(node2);
	with(tempObj.domNode.style){
		top = "2px";
		height = "13px";
		if(__env__.is_IE){
			left = accumLeft + "px";
			position = "absolute";
		}else{
			cssFloat = "left";
		}
	}
	node1.appendChild(tempObj.domNode);
	return (parseInt(tempObj.domNode.style.width)+6);
}

__scripts__.finalize(__config__.widgetPath+"tool_bar_widget.js");
