// $Id: tree_view_widget.js,v 1.34 2003/01/26 20:15:33 russcoon Exp $
// Copyright (c) 2000-2002 Alex Russell
// Licensed under the Academic Free License version 1.1

// Filename:		tree_view_widget.js
// Purpose:		provide a definition file for the tree view widget.
// Classes:		NW_WIDGET_tree
// Global Objects:	none
// Dependencies:	widget_core.js, theme_core.js, environ_core.js, component_registry.js

// FIXME: need to investigate how hard/easy it will be to dynamically add and remove nodes from the tree widget

with(__scripts__){
	provide(__config__.widgetPath+"tree_view_widget.js");
	require(__config__.corePath+"environ_core.js");
	require(__config__.corePath+"theme_core.js");
	require(__config__.corePath+"widget_core.js");
	require(__config__.corePath+"component_registry.js");
}

function NW_WIDGET_tree_data(domNode){
	//set inheritance
	this.parent = NW_widgetComponent;
	this.parent(domNode);
	delete this.parent;

	// override parent values
	this.isTopLevelComp = false;
	this.isDraggable = false;
	this.componentType = "tree_data_node";

	//this.parent(domNode);
	var tdnm = new NW_element_maker_obj("div");
	// tdnm.setEvent("onClick","__components__.getComponent('"+this.globIdNum+"').doClick(event);");
	tdnm.setEvent("onDblClick","__components__.getComponent('"+this.globIdNum+"').doDblClick(event);");
	//prevent bubbling over this element
	if(__env__.is_IE){ tdnm.setEvent("onClick","window.event.cancelBubble = true;");
	}else{ tdnm.setEvent("onClick","event.stopPropagation();"); }
	//get an element
	this.domNode = tdnm.getElement();
	this.domNode.id = this.globIdNum;
	this.domNode.setAttribute("NW_compID", this.globIdNum);

	// class specific members
	this.contentNode = null;
	this.childComps = new Array();
	this.childCompsNode = null;
	this.parentNode = null;
	this.isFldrOpen = false;
	this.isBottom = false;
	this.leftImg = null;
	this.action = "";
	this.text = "";

	this.makeNode = function(){
		with(this.domNode.style){
			position = "relative";
			left = "20px";
			margin = "0px";
			border = "none";
		}

		this.contentNode = document.createElement('div');
		with(this.contentNode.style){
			height = "20px";
			margin = "0px";
			border = "none";
		}

		this.setLeftImg();
		if(!((this.childComps.length==0)||(this.isBottom))){
			this.domNode.style.background = "url('"+__config__.imgPath+"tree_line_bg.gif')";
			this.domNode.style.backgroundRepeat = "repeat-y";
		}
		with(this.leftImg){
			setAttribute("border", "0");
			setAttribute("align", "left");
			setAttribute("hspace", "0");
			setAttribute("vspace", "0");
		}

		var asm = new NW_element_maker_obj("span");
		if(this.action!=""){
			asm.setEvent("onClick", this.action);
		}
		if(this.childComps.length!=0){
			stdout(this.text);
			asm.setEvent("onClick","__components__.getComponent('"+this.globIdNum+"').doClick(event);");
		}
		var as = asm.getElement();
		as.appendChild(document.createTextNode(this.text));
		this.contentNode.appendChild(this.leftImg);
		this.contentNode.appendChild(as);
		this.domNode.appendChild(this.contentNode);
		return true;
	}

	this.toggleExpanded = function(){
		var x = null;
		for(x in this.childComps){
			if(this.isFldrOpen){
				this.domNode.removeChild(this.childComps[x].domNode);
			}else{
				//this.childComps[x].makeNode();
				this.domNode.appendChild(this.childComps[x].domNode);
			}
		}
		this.setLeftImg();
		this.isFldrOpen = (!this.isFldrOpen);
		if(__env__.is_IE){
			with(this.domNode.style){
				width="0%"; width="100%";
			}
		}
		return true;
	}

	this.doClick = function(evt){
		// FIXME: should we only toggle the expanded thing on double click instead?
		var evtSrc = __util__.evtTarget(evt);
		if(__components__.getComponentFromNode(evtSrc).globIdNum == this.globIdNum){
			//if we clicked on the image, determine if were a folder or not
			if(this.childComps.length!=0){
				this.toggleExpanded();
			}else{
				//otherwise, don't do anything...
				eval(this.action);
				return true;
			}
		}
		return true;
	}
	
	this.doDblClick = function(event){
		return true;
		//stdout('calling doDblClick()');
	}

	//tree image refs
	var imgPf = ".png";
	if(__env__.is_IE){imgPf=".gif";}
	var tiP = __config__.imgPath;
	this.lfcImgPath	= tiP+"last_fldr_closed"+imgPf;
	this.fcImgPath	= tiP+"fldr_closed"+imgPf;
	this.lfoImgPath	= tiP+"last_fldr_open"+imgPf;
	this.foImgPath	= tiP+"fldr_open"+imgPf;
	this.lchImgPath	= tiP+"last_child_node"+imgPf;
	this.chImgPath	= tiP+"child_node"+imgPf;

	this.setLeftImg = function(){
		var isFldr = false;
		var isNew = true;
		var oldsrc = "";
		if(this.childComps.length > 0){isFldr=true;}
		if(this.leftImg != null){isNew=false; oldsrc=this.leftImg.src;}
		var tim = new NW_element_maker_obj("img");
		if(isFldr){
			//tim.setEvent("onClick","__components__.getComponent('"+this.globIdNum+"').isFldrOpen=!(__components__.getComponent('"+this.globIdNum+"').isFldrOpen);");
			tim.setEvent("onClick","__components__.getComponent('"+this.globIdNum+"').doClick(event);");
		}
		var ti = tim.getElement();
		ti.setAttribute("border", "0");
		ti.setAttribute("border", "0");
		ti.setAttribute("align", "left");
		ti.setAttribute("hspace", "0");
		ti.setAttribute("vspace", "0");
		if(isFldr){
			if(this.isBottom){
				if(isNew){
					ti.src = this.lfcImgPath;
					this.leftImg = ti;
				}else{
					if(!this.isFldrOpen){//if it's currently set to closed...
						this.leftImg.src = this.lfoImgPath; //set to open
						ti.src = this.lfoImgPath; //set to open
					}else{
						ti.src = this.lfcImgPath; //set to closed
					}
					this.contentNode.replaceChild(ti, this.leftImg);
					this.leftImg = ti;
				}
			}else{ //if not the bottom, do the same thing, just the other images
				if(isNew){
					ti.src = this.fcImgPath;
					this.leftImg = ti;
				}else{
					if(!this.isFldrOpen){//if it's currently set to closed...
						ti.src = this.foImgPath; //set to open
					}else{
						//this.leftImg.src = this.fcImgPath; //set to closed
						ti.src = this.fcImgPath; //set to closed
					}
					this.contentNode.replaceChild(ti, this.leftImg);
					this.leftImg = ti;
				}
			}
		}else{ // if not a folder, then it's a regular leaf image...we're assuming isNew because we woudln't be requesting an image otherwise
			this.leftImg = ti;
			if(this.isBottom){ this.leftImg.src = this.lchImgPath;
			}else{ this.leftImg.src = this.chImgPath; }
		}
	}

	this.inspectData = function(dataBlock, par){
		if(arguments.length == 3){this.isBottom = true;}
		if(dataBlock['dispText']){
			this.text = dataBlock['dispText'];
		}
		if(dataBlock['action']){
			this.action = dataBlock['action'];
		}
		if(par!=null){
			this.parentNode=par;
		}
		if((dataBlock['nwComponents'])&&(dataBlock['nwComponents']['node'])){
			var tcomps = dataBlock['nwComponents'];
			for(var x=0;  x < tcomps['node'].length; x++){
				var twidget = new NW_WIDGET_tree_data();
				this.childComps[this.childComps.length]=twidget;
				if(x != tcomps['node'].length-1){
					twidget.inspectData(tcomps['node'][x], this); //recurse
				}else{
					twidget.inspectData(tcomps['node'][x], this, true); //recurse
				}
			}
		}

		this.makeNode();
		
		if(dataBlock['opened']){
			if(dataBlock['opened']=="true"){
				this.toggleExpanded();
			}
		}
	}
}
NW_WIDGET_tree_data.prototype = new NW_widgetComponent; //deep inheritance support

function NW_WIDGET_tree(domNode){
	this.parent = NW_widgetComponent;
	this.parent(domNode); //call parent constructor
	delete this.parent;

	// override parent values
	this.isTopLevelComp = false;
	this.isDraggable = false;
	this.componentType = "tree";

	//tree specific stuff...
	this.treeComponent = null;

	//for new constructor
	this.optWidgets = new Array();

	this.setData = function(dobj){
		for(var x = 0; x < dobj['node'].length; x++){
			this.optWidgets[this.optWidgets.length] = new NW_WIDGET_tree_data();
			if(x != dobj['node'].length-1){
				this.optWidgets[this.optWidgets.length-1].inspectData(dobj['node'][x], null);
			}else{
				this.optWidgets[this.optWidgets.length-1].inspectData(dobj['node'][x], null, true);
			}
		}
		for(x in this.optWidgets){
			this.domNode.appendChild(this.optWidgets[x].domNode);
		}
	}
}
__widgets__.register("tree", "NW_WIDGET_INLINE_FACTORY_tree", "NW_WIDGET_FACTORY_tree");
NW_WIDGET_tree.prototype = new NW_widgetComponent;


////////////////////////////// WIDGET FACTORY //////////////////////////////////
function NW_WIDGET_FACTORY_tree(){
	// we need to create the top level tree nodes here.
	var dnGen = new NW_element_maker_obj("div");
	var dNode = dnGen.getElement();

	with(dNode.style){
		position = "relative";
		height = "30px";
		cursor = "default";
		overflow = "visible";
		padding = "0px";
		margin = "0px";
	}

	with(__theme__){
		setStyleByAttr(dNode, "main_bgcolor", "backgroundColor");
		setStyleByAttr(dNode, "main_border_color", "borderColor");
		setStyleByAttr(dNode, "menu_font_size", "fontSize");
		setStyleByAttr(dNode, "menu_font_color", "color");
	}
		
	var contentObj = new NW_WIDGET_tree(dNode);
	dNode.id = contentObj.globIdNum;
	dNode.setAttribute("NW_compID", contentObj.globIdNum);
	return contentObj;
}

function NW_WIDGET_INLINE_FACTORY_tree(domNode){
	var tree = NW_WIDGET_FACTORY_tree(); //create a tree object
	var attrs = ['dispText', 'action', 'opened'];
	// var tDObj =  __util__.genParse(domNode, null, "nType", attrs); //parse and store data
	var tDObj = __util__.parseNWComponents(domNode, attrs);
	tree.setData(tDObj['nwComponents']);
	return tree;
}

__scripts__.finalize(__config__.widgetPath+"tree_view_widget.js");
